package tr;
import robocode.*;
import java.awt.Color;


public class Walker extends AdvancedRobot
{
        
		
        Enemy target;					
        final double PI = Math.PI;			
        int direction = 1;				
        double firePower;       			

        public void run() {
                target = new Enemy();
                target.distance = 100000;			
                setColors(Color.darkGray,Color.gray,Color.cyan);

                
                setAdjustGunForRobotTurn(true);
                setAdjustRadarForGunTurn(true);
                turnRadarRightRadians(2*PI);			
                while(true) {
                        doMovement();				
                        doFirePower();				
                        doScanner();				
                        doGun();
                        out.println(target.distance);		
                        fire(firePower);
                        execute();				
                }
        }

        void doFirePower() {
                firePower = 400/target.distance;
        }

        void doMovement() {
                if (getTime()%20 == 0)  { 
                       direction *= -1;		
                       setAhead(direction*300);	
                }
				
				if ((getHeight()+45) > getBattleFieldHeight())	{
                		
						direction *= -1;
						setAhead(direction*300);
			   }	
						
				if (getHeight() < 45) {
                		
						direction *= -1;
						setAhead(direction*300);
			   }	
				
				
				if ((getWidth()+45) > getBattleFieldWidth() ) {
                		
						direction *= -1;
						setAhead(direction*300);
			   }	
			
			
			if  (getWidth() < 45)	{
                		
						direction *= -1;
						setAhead(direction*300);
			   }	

                setTurnRightRadians(target.bearing + (PI/2)); 
				
				if (getTime()%50 == 0)  { 
                       setTurnRight(PI/2);
                       setAhead(direction*450);	
                }


				
				if (getTime()%35 == 0)  { 
                       setTurnRight(PI/4);
                       setAhead(direction*100);	
                }


				
				if (getTime()%100 == 0)  { 
                       setTurnRight(PI/1.5);
                       setAhead(direction*500);	
                }
        }

        void doScanner() {
                double radarOffset;
                if (getTime() - target.ctime > 4) { 	//if we haven't seen anybody for a bit....
                        radarOffset = 360;		//rotate the radar to find a target
                } else {

                        //next is the amount we need to rotate the radar by to scan where the target is now
                        radarOffset = getRadarHeadingRadians() - absbearing(getX(),getY(),target.x,target.y);

                        //this adds or subtracts small amounts from the bearing for the radar to produce the wobbling
                        //and make sure we don't lose the target
                        if (radarOffset < 0)
                        radarOffset -= PI/8;
                        else
                        radarOffset += PI/8;
                }
                //turn the radar
                setTurnRadarLeftRadians(NormaliseBearing(radarOffset));
        }

        void doGun() {

                //works out how long it would take a bullet to travel to where the enemy is *now*
                //this is the best estimation we have
                long time = getTime() + (int)(target.distance/(20-(3*firePower)));

                //offsets the gun by the angle to the next shot based on linear targeting provided by the enemy class
                double gunOffset = getGunHeadingRadians() - absbearing(getX(),getY(),target.guessX(time),target.guessY(time));
                setTurnGunLeftRadians(NormaliseBearing(gunOffset));
        }


        //if a bearing is not within the -pi to pi range, alters it to provide the shortest angle
        double NormaliseBearing(double ang) {
                if (ang > PI)
                ang -= 2*PI;
                if (ang < -PI)
                ang += 2*PI;
                return ang;
        }

        //if a heading is not within the 0 to 2pi range, alters it to provide the shortest angle
        double NormaliseHeading(double ang) {
                if (ang > 2*PI)
                ang -= 2*PI;
                if (ang < 0)
                ang += 2*PI;
                return ang;
        }

        //returns the distance between two x,y coordinates
        public double getrange( double x1,double y1, double x2,double y2 )
        {
                double xo = x2-x1;
                double yo = y2-y1;
                double h = Math.sqrt( xo*xo + yo*yo );
                return h;
        }

        //gets the absolute bearing between to x,y coordinates
        public double absbearing( double x1,double y1, double x2,double y2 )
        {
                double xo = x2-x1;
                double yo = y2-y1;
                double h = getrange( x1,y1, x2,y2 );
                if( xo > 0 && yo > 0 )
                {
                        return Math.asin( xo / h );
                }
                if( xo > 0 && yo < 0 )
                {
                        return Math.PI - Math.asin( xo / h );
                }
                if( xo < 0 && yo < 0 )
                {
                        return Math.PI + Math.asin( -xo / h );
                }
                if( xo < 0 && yo > 0 )
                {
                        return 2.0*Math.PI - Math.asin( -xo / h );
                }
                return 0;
        }


        /**
        * onScannedRobot: What to do when you see another robot
        */
        public void onScannedRobot(ScannedRobotEvent e) {
                //if we have found a closer robot....
			
                if ((e.getDistance() < target.distance)||(target.name == e.getName())) {
                        //the next line gets the absolute bearing to the point where the bot is
                        double absbearing_rad = (getHeadingRadians()+e.getBearingRadians())%(2*PI);
						
                        //this section sets all the information about our target
                        target.name = e.getName();
                        target.x = getX()+Math.sin(absbearing_rad)*e.getDistance(); //works out the x coordinate of where the target is
                        target.y = getY()+Math.cos(absbearing_rad)*e.getDistance(); //works out the y coordinate of where the target is
                        target.bearing = e.getBearingRadians();
                        target.head = e.getHeadingRadians();
                        target.ctime = getTime();				//game time at which this scan was produced
                        target.speed = e.getVelocity();
                        target.distance = e.getDistance();

                }
        }

        public void onRobotDeath(RobotDeathEvent e) {
                if (e.getName() == target.name)
                target.distance = 10000; //this will effectively make it search for a new target
        }

		public void onWin(WinEvent e) {
		for (int i = 0; i < 50; i++)
		{
			setTurnRight(30);
			setTurnGunRight(10);
			setTurnRadarLeft(30);
		}
	}
	
}

class Enemy {
        /*
        * ok, we should really be using accessors and mutators here,
        * (i.e getName() and setName()) but life's too short.
        */
        String name;
        public double bearing;
        public double head;
        public long ctime; //game time that the scan was produced
        public double speed;
        public double x,y;
        public double distance;
        public double guessX(long when)
        {
                long diff = when - ctime;
                return x+Math.sin(head)*speed*diff;
        }
        public double guessY(long when)
        {
                long diff = when - ctime;
                return y+Math.cos(head)*speed*diff;
        }

}